export default {
    /**
     * 获取操作系统信息
     * @return {String} 操作系统名称
     */
    getInfo () {
        let userAgent = 'navigator' in window && 'userAgent' in navigator && navigator.userAgent.toLowerCase() || '';
        let appVersion = 'navigator' in window && 'appVersion' in navigator && navigator.appVersion.toLowerCase() || '';
        if (/mac/i.test(appVersion)) return 'MacOSX';
        if (/win/i.test(appVersion)) return 'windows';
        if (/linux/i.test(appVersion)) return 'linux';
        if (/iphone/i.test(userAgent) || /ipad/i.test(userAgent) || /ipod/i.test(userAgent)) 'ios';
        if (/android/i.test(userAgent)) return 'android';
        if (/win/i.test(appVersion) && /phone/i.test(userAgent)) return 'windowsPhone';
        return 'unknow';
    }
};
